﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Xml.Serialization;
using Windows.Annotations;

namespace Windows
{
    [XmlRoot(Namespace = "urn:widow-windows-schema", ElementName = "Windows")]
    public class Windows : INotifyPropertyChanged
    {
        #region Public Enums, Properties and Fields

        [XmlElement(ElementName = "Window")]
        public List<Window> Window
        {
            get => _window;
            set
            {
                if (Equals(value, _window))
                {
                    return;
                }

                _window = value;
                OnPropertyChanged();
            }
        }

        #endregion

        #region Private Delegates, Events, Enums, Properties, Indexers and Fields

        private List<Window> _window = new List<Window>();

        #endregion

        #region Constructors, Destructors and Finalizers

        [UsedImplicitly]
        public Windows()
        {
        }

        #endregion

        #region Interface

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region Private Methods

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}